<template>
	<mind-view>
		<template v-slot:toolbar-actions>
			<el-button type="primary" size="small" @click="$refs.formulario?.onSubmit()" :disabled="!modificado" >Aplicar Cambios</el-button>
		</template>
		<mind-form  
			v-model="recurso"  v-model:modified="modificado"
			@submit="onSubmit" v-loading="isLoading"
			ref="formulario" 
			>
			<template v-slot="{form}">
					<el-form-item label="Nombre">
								<el-input v-model="form.nombre" />
					</el-form-item>
					<el-row  >
							<el-col  :lg="12">
								<el-form-item label="Direccion">
										<select-lugar calles placeholder="Calle" v-model="form.calle" />
								</el-form-item>
							</el-col>
							<el-col  :lg="12">
								<el-form-item label="Numero">
									<el-col  :lg="8">
										<el-input placeholder="Numero" type="text" v-model.number="form.numero" />
									</el-col>
									<el-col  :lg="8">
										<el-input clearable placeholder="Piso" v-model.number="form.piso" />
									</el-col>
									<el-col  :lg="8">
										<el-input placeholder="Depto" v-model="form.depto" />
									</el-col>
								</el-form-item>
							</el-col>
					</el-row>
					<el-row >
						<el-col  :lg="12">
							<el-form-item label="Entre" >
									<select-lugar calles placeholder="Calle 1" v-model="form.calle1" />
							</el-form-item>
						</el-col>
						<el-col  :lg="12">
							<el-form-item label="y" >
									<select-lugar calles placeholder="Calle 2" v-model="form.calle2" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row >
						<el-col  :lg="12">
							<el-form-item label="Localidad">
								<el-input v-model="form.localidad" />
							</el-form-item>
						</el-col>
						<el-col  :lg="12">
							<el-form-item label="Partido">
								<el-input v-model="form.partido" />
							</el-form-item>
						</el-col>
						<el-col  :lg="12">
							<el-form-item label="Provincia">
								<el-input v-model="form.provincia" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row >
						<el-col  :lg="12">
							<el-form-item label="Teléfono Fijo">
								<el-input v-model="form.telefono" />
							</el-form-item>
						</el-col>
						<el-col  :lg="12">
							<el-form-item label="Movil">
								<el-input v-model="form.movil" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row >
						<el-col :lg="12" >
							<el-form-item label="Correo">
								<el-input v-model="form.correo" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row >
						<el-col :lg="24" >
							<el-form-item  label="Notas">
								<el-input type="textarea" rows="5" v-model="form.obs" />
							</el-form-item>
						</el-col>
					</el-row>
			</template>
		</mind-form>
	</mind-view>
</template>
<script>

import clientes from '@/model/clientes'
import selectLugar from '@/components/select-lugar'

export default {
	components:{
		selectLugar
	},
	async created(){
		this.isLoading = true;
		let id = this.$route.params.id;
		if (id == "new") {
			this.recurso = clientes.new()
		} else {
			this.recurso = await clientes.get(id)

		}
		this.isLoading = false;
	},
	computed: {
		esNuevo() {
			return this.recurso?._isNew
		}
		
	},

	methods: {
		async onSubmit(v) {
			delete(v.ultimaActualizacion)
			delete(v.estado)
			this.recurso = v
			const key = clientes.getKey()
			const esNuevo = this.esNuevo
			if(esNuevo) {
				this.recurso = await clientes.post(this.recurso)
				.then((response)=>{
					const id = response[0][key]
					this.$message({
						type: 'success',
						message: `Chofer creadao correctamente`,
					})
					//modifico la ruta
					const path = this.$router.currentRoute.path.replace(/\/new$/, `/${id}`)
					this.$router.replace(path)
				})
			} else {
				this.recurso = await clientes.patch(this.recurso)
				this.$message({
					type: 'success',
					message: "Chofer actualizado correctamente",
				})
			}

		},
	},
	data() {
		return {
			modificado: false,
			recurso: {},
		}
	}
}
</script>